﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using VISSIM_COMSERVERLib;

namespace US301
{
    class Program
    {
        //find max
        static double findMax(double[] arr)
        {
            double curMax = -1;
            double newVal;
            for (int i = 0; i < arr.Count(); i++)
            {
                newVal = arr[i];
                if (newVal > curMax)
                {
                    curMax = newVal;
                }
            }
            return curMax;
        }

        static void Main(string[] args)
        {
            Vissim vis = new Vissim();
            vis.LoadNet("i:\\us301@Croom\\network.inp", 0);
            Simulation sim = vis.Simulation;

            // Set evaluation variables
            Evaluation eva = vis.Evaluation;
            eva.set_AttValue("SCDETRECORD", true);
            eva.set_AttValue("SIGNALCHANGES", true);
            eva.set_AttValue("VEHICLERECORD", true);
            eva.set_AttValue("DATACOLLECTION", true);
            
            // set controller
            SignalControllers sc = vis.Net.SignalControllers;

            //set controller for the intersection
            SignalController sc1 = sc.GetSignalControllerByNumber(1);
            SignalGroups sc1_groups = sc1.SignalGroups;
            SignalGroup sc1_group1 = sc1_groups.GetSignalGroupByNumber(1); //left
            SignalGroup sc1_group2 = sc1_groups.GetSignalGroupByNumber(2); //through
            SignalGroup sc1_group3 = sc1_groups.GetSignalGroupByNumber(3); // croom

            //set detector
            Detectors Dets1 = sc1.Detectors;
            
            //SB through (right lane)
            Detector Det11001 = Dets1.GetDetectorByNumber(11001);
            Detector Det11002 = Dets1.GetDetectorByNumber(11002);
            Detector Det11003 = Dets1.GetDetectorByNumber(11003);
            Detector Det11004 = Dets1.GetDetectorByNumber(11004);
            Detector Det11005 = Dets1.GetDetectorByNumber(11005);
            Detector Det11006 = Dets1.GetDetectorByNumber(11006);
            Detector Det11007 = Dets1.GetDetectorByNumber(11007);
            Detector Det11008 = Dets1.GetDetectorByNumber(11008);
            Detector Det11009 = Dets1.GetDetectorByNumber(11009);
            Detector Det11010 = Dets1.GetDetectorByNumber(11010);
            Detector Det11011 = Dets1.GetDetectorByNumber(11011);
            Detector Det11012 = Dets1.GetDetectorByNumber(11012);
            Detector Det11013 = Dets1.GetDetectorByNumber(11013);
            Detector Det11014 = Dets1.GetDetectorByNumber(11014);
            Detector Det11015 = Dets1.GetDetectorByNumber(11015);
            Detector Det11016 = Dets1.GetDetectorByNumber(11016);
            Detector Det11017 = Dets1.GetDetectorByNumber(11017);
            Detector Det11018 = Dets1.GetDetectorByNumber(11018);
            Detector Det11019 = Dets1.GetDetectorByNumber(11019);
            Detector Det11020 = Dets1.GetDetectorByNumber(11020);
            Detector Det11021 = Dets1.GetDetectorByNumber(11021);
            Detector Det11022 = Dets1.GetDetectorByNumber(11022);
            Detector Det11023 = Dets1.GetDetectorByNumber(11023);
            Detector Det11024 = Dets1.GetDetectorByNumber(11024);
            Detector Det11025 = Dets1.GetDetectorByNumber(11025);
            Detector Det11026 = Dets1.GetDetectorByNumber(11026);
            Detector Det11027 = Dets1.GetDetectorByNumber(11027);
            Detector Det11028 = Dets1.GetDetectorByNumber(11028);
            Detector Det11029 = Dets1.GetDetectorByNumber(11029);
            Detector Det11030 = Dets1.GetDetectorByNumber(11030);
            Detector Det11031 = Dets1.GetDetectorByNumber(11031);
            Detector Det11032 = Dets1.GetDetectorByNumber(11032);
            Detector Det11033 = Dets1.GetDetectorByNumber(11033);
            Detector Det11034 = Dets1.GetDetectorByNumber(11034);
            Detector Det11035 = Dets1.GetDetectorByNumber(11035);
            Detector Det11036 = Dets1.GetDetectorByNumber(11036);
            Detector Det11037 = Dets1.GetDetectorByNumber(11037);
            Detector Det11038 = Dets1.GetDetectorByNumber(11038);
            Detector Det11039 = Dets1.GetDetectorByNumber(11039);
            Detector Det11040 = Dets1.GetDetectorByNumber(11040);
            Detector Det11041 = Dets1.GetDetectorByNumber(11041);
            Detector Det11042 = Dets1.GetDetectorByNumber(11042);
            Detector Det11043 = Dets1.GetDetectorByNumber(11043);
            Detector Det11044 = Dets1.GetDetectorByNumber(11044);
            Detector Det11045 = Dets1.GetDetectorByNumber(11045);
            Detector Det11046 = Dets1.GetDetectorByNumber(11046);
            Detector Det11047 = Dets1.GetDetectorByNumber(11047);
            Detector Det11048 = Dets1.GetDetectorByNumber(11048);
            Detector Det11049 = Dets1.GetDetectorByNumber(11049);
            Detector Det11050 = Dets1.GetDetectorByNumber(11050);
            Detector Det11051 = Dets1.GetDetectorByNumber(11051);
            Detector Det11052 = Dets1.GetDetectorByNumber(11052);
            Detector Det11053 = Dets1.GetDetectorByNumber(11053);
            Detector Det11054 = Dets1.GetDetectorByNumber(11054);
            Detector Det11055 = Dets1.GetDetectorByNumber(11055);
            Detector Det11056 = Dets1.GetDetectorByNumber(11056);
            Detector Det11057 = Dets1.GetDetectorByNumber(11057);
            Detector Det11058 = Dets1.GetDetectorByNumber(11058);
            Detector Det11059 = Dets1.GetDetectorByNumber(11059);
            Detector Det11060 = Dets1.GetDetectorByNumber(11060);
            Detector Det11061 = Dets1.GetDetectorByNumber(11061);
            Detector Det11062 = Dets1.GetDetectorByNumber(11062);
            Detector Det11063 = Dets1.GetDetectorByNumber(11063);
            Detector Det11064 = Dets1.GetDetectorByNumber(11064);
            Detector Det11065 = Dets1.GetDetectorByNumber(11065);
            Detector Det11066 = Dets1.GetDetectorByNumber(11066);
            Detector Det11067 = Dets1.GetDetectorByNumber(11067);
            Detector Det11068 = Dets1.GetDetectorByNumber(11068);
            Detector Det11069 = Dets1.GetDetectorByNumber(11069);
            Detector Det11070 = Dets1.GetDetectorByNumber(11070);
            Detector Det11071 = Dets1.GetDetectorByNumber(11071);
            Detector Det11072 = Dets1.GetDetectorByNumber(11072);
            Detector Det11073 = Dets1.GetDetectorByNumber(11073);
            Detector Det11074 = Dets1.GetDetectorByNumber(11074);
            Detector Det11075 = Dets1.GetDetectorByNumber(11075);
            Detector Det11076 = Dets1.GetDetectorByNumber(11076);
            Detector Det11077 = Dets1.GetDetectorByNumber(11077);
            Detector Det11078 = Dets1.GetDetectorByNumber(11078);
            Detector Det11079 = Dets1.GetDetectorByNumber(11079);
            Detector Det11080 = Dets1.GetDetectorByNumber(11080);
            Detector Det11081 = Dets1.GetDetectorByNumber(11081);
            Detector Det11082 = Dets1.GetDetectorByNumber(11082);
            Detector Det11083 = Dets1.GetDetectorByNumber(11083);
            Detector Det11084 = Dets1.GetDetectorByNumber(11084);
            Detector Det11085 = Dets1.GetDetectorByNumber(11085);
            Detector Det11086 = Dets1.GetDetectorByNumber(11086);
            Detector Det11087 = Dets1.GetDetectorByNumber(11087);
            Detector Det11088 = Dets1.GetDetectorByNumber(11088);
            Detector Det11089 = Dets1.GetDetectorByNumber(11089);
            Detector Det11090 = Dets1.GetDetectorByNumber(11090);
            Detector Det11091 = Dets1.GetDetectorByNumber(11091);
            Detector Det11092 = Dets1.GetDetectorByNumber(11092);
            Detector Det11093 = Dets1.GetDetectorByNumber(11093);
            Detector Det11094 = Dets1.GetDetectorByNumber(11094);
            Detector Det11095 = Dets1.GetDetectorByNumber(11095);
            Detector Det11096 = Dets1.GetDetectorByNumber(11096);
            Detector Det11097 = Dets1.GetDetectorByNumber(11097);
            Detector Det11098 = Dets1.GetDetectorByNumber(11098);
            Detector Det11099 = Dets1.GetDetectorByNumber(11099);

            //SB through (left lane)
            Detector Det12001 = Dets1.GetDetectorByNumber(12001);
            Detector Det12002 = Dets1.GetDetectorByNumber(12002);
            Detector Det12003 = Dets1.GetDetectorByNumber(12003);
            Detector Det12004 = Dets1.GetDetectorByNumber(12004);
            Detector Det12005 = Dets1.GetDetectorByNumber(12005);
            Detector Det12006 = Dets1.GetDetectorByNumber(12006);
            Detector Det12007 = Dets1.GetDetectorByNumber(12007);
            Detector Det12008 = Dets1.GetDetectorByNumber(12008);
            Detector Det12009 = Dets1.GetDetectorByNumber(12009);
            Detector Det12010 = Dets1.GetDetectorByNumber(12010);
            Detector Det12011 = Dets1.GetDetectorByNumber(12011);
            Detector Det12012 = Dets1.GetDetectorByNumber(12012);
            Detector Det12013 = Dets1.GetDetectorByNumber(12013);
            Detector Det12014 = Dets1.GetDetectorByNumber(12014);
            Detector Det12015 = Dets1.GetDetectorByNumber(12015);
            Detector Det12016 = Dets1.GetDetectorByNumber(12016);
            Detector Det12017 = Dets1.GetDetectorByNumber(12017);
            Detector Det12018 = Dets1.GetDetectorByNumber(12018);
            Detector Det12019 = Dets1.GetDetectorByNumber(12019);
            Detector Det12020 = Dets1.GetDetectorByNumber(12020);
            Detector Det12021 = Dets1.GetDetectorByNumber(12021);
            Detector Det12022 = Dets1.GetDetectorByNumber(12022);
            Detector Det12023 = Dets1.GetDetectorByNumber(12023);
            Detector Det12024 = Dets1.GetDetectorByNumber(12024);
            Detector Det12025 = Dets1.GetDetectorByNumber(12025);
            Detector Det12026 = Dets1.GetDetectorByNumber(12026);
            Detector Det12027 = Dets1.GetDetectorByNumber(12027);
            Detector Det12028 = Dets1.GetDetectorByNumber(12028);
            Detector Det12029 = Dets1.GetDetectorByNumber(12029);
            Detector Det12030 = Dets1.GetDetectorByNumber(12030);
            Detector Det12031 = Dets1.GetDetectorByNumber(12031);
            Detector Det12032 = Dets1.GetDetectorByNumber(12032);
            Detector Det12033 = Dets1.GetDetectorByNumber(12033);
            Detector Det12034 = Dets1.GetDetectorByNumber(12034);
            Detector Det12035 = Dets1.GetDetectorByNumber(12035);
            Detector Det12036 = Dets1.GetDetectorByNumber(12036);
            Detector Det12037 = Dets1.GetDetectorByNumber(12037);
            Detector Det12038 = Dets1.GetDetectorByNumber(12038);
            Detector Det12039 = Dets1.GetDetectorByNumber(12039);
            Detector Det12040 = Dets1.GetDetectorByNumber(12040);
            Detector Det12041 = Dets1.GetDetectorByNumber(12041);
            Detector Det12042 = Dets1.GetDetectorByNumber(12042);
            Detector Det12043 = Dets1.GetDetectorByNumber(12043);
            Detector Det12044 = Dets1.GetDetectorByNumber(12044);
            Detector Det12045 = Dets1.GetDetectorByNumber(12045);
            Detector Det12046 = Dets1.GetDetectorByNumber(12046);
            Detector Det12047 = Dets1.GetDetectorByNumber(12047);
            Detector Det12048 = Dets1.GetDetectorByNumber(12048);
            Detector Det12049 = Dets1.GetDetectorByNumber(12049);
            Detector Det12050 = Dets1.GetDetectorByNumber(12050);
            Detector Det12051 = Dets1.GetDetectorByNumber(12051);
            Detector Det12052 = Dets1.GetDetectorByNumber(12052);
            Detector Det12053 = Dets1.GetDetectorByNumber(12053);
            Detector Det12054 = Dets1.GetDetectorByNumber(12054);
            Detector Det12055 = Dets1.GetDetectorByNumber(12055);
            Detector Det12056 = Dets1.GetDetectorByNumber(12056);
            Detector Det12057 = Dets1.GetDetectorByNumber(12057);
            Detector Det12058 = Dets1.GetDetectorByNumber(12058);
            Detector Det12059 = Dets1.GetDetectorByNumber(12059);
            Detector Det12060 = Dets1.GetDetectorByNumber(12060);
            Detector Det12061 = Dets1.GetDetectorByNumber(12061);
            Detector Det12062 = Dets1.GetDetectorByNumber(12062);
            Detector Det12063 = Dets1.GetDetectorByNumber(12063);
            Detector Det12064 = Dets1.GetDetectorByNumber(12064);
            Detector Det12065 = Dets1.GetDetectorByNumber(12065);
            Detector Det12066 = Dets1.GetDetectorByNumber(12066);
            Detector Det12067 = Dets1.GetDetectorByNumber(12067);
            Detector Det12068 = Dets1.GetDetectorByNumber(12068);
            Detector Det12069 = Dets1.GetDetectorByNumber(12069);
            Detector Det12070 = Dets1.GetDetectorByNumber(12070);
            Detector Det12071 = Dets1.GetDetectorByNumber(12071);
            Detector Det12072 = Dets1.GetDetectorByNumber(12072);
            Detector Det12073 = Dets1.GetDetectorByNumber(12073);
            Detector Det12074 = Dets1.GetDetectorByNumber(12074);
            Detector Det12075 = Dets1.GetDetectorByNumber(12075);
            Detector Det12076 = Dets1.GetDetectorByNumber(12076);
            Detector Det12077 = Dets1.GetDetectorByNumber(12077);
            Detector Det12078 = Dets1.GetDetectorByNumber(12078);
            Detector Det12079 = Dets1.GetDetectorByNumber(12079);
            Detector Det12080 = Dets1.GetDetectorByNumber(12080);
            Detector Det12081 = Dets1.GetDetectorByNumber(12081);
            Detector Det12082 = Dets1.GetDetectorByNumber(12082);
            Detector Det12083 = Dets1.GetDetectorByNumber(12083);
            Detector Det12084 = Dets1.GetDetectorByNumber(12084);
            Detector Det12085 = Dets1.GetDetectorByNumber(12085);
            Detector Det12086 = Dets1.GetDetectorByNumber(12086);
            Detector Det12087 = Dets1.GetDetectorByNumber(12087);
            Detector Det12088 = Dets1.GetDetectorByNumber(12088);
            Detector Det12089 = Dets1.GetDetectorByNumber(12089);
            Detector Det12090 = Dets1.GetDetectorByNumber(12090);
            Detector Det12091 = Dets1.GetDetectorByNumber(12091);
            Detector Det12092 = Dets1.GetDetectorByNumber(12092);
            Detector Det12093 = Dets1.GetDetectorByNumber(12093);
            Detector Det12094 = Dets1.GetDetectorByNumber(12094);
            Detector Det12095 = Dets1.GetDetectorByNumber(12095);
            Detector Det12096 = Dets1.GetDetectorByNumber(12096);
            Detector Det12097 = Dets1.GetDetectorByNumber(12097);
            Detector Det12098 = Dets1.GetDetectorByNumber(12098);
            Detector Det12099 = Dets1.GetDetectorByNumber(12099);

            // SB left turn
            Detector Det13001 = Dets1.GetDetectorByNumber(13001);
            Detector Det13002 = Dets1.GetDetectorByNumber(13002);
            Detector Det13003 = Dets1.GetDetectorByNumber(13003);
            Detector Det13004 = Dets1.GetDetectorByNumber(13004);
            Detector Det13005 = Dets1.GetDetectorByNumber(13005);
            Detector Det13006 = Dets1.GetDetectorByNumber(13006);
            Detector Det13007 = Dets1.GetDetectorByNumber(13007);
            Detector Det13008 = Dets1.GetDetectorByNumber(13008);
            Detector Det13009 = Dets1.GetDetectorByNumber(13009);
            Detector Det13010 = Dets1.GetDetectorByNumber(13010);
            Detector Det13011 = Dets1.GetDetectorByNumber(13011);
            Detector Det13012 = Dets1.GetDetectorByNumber(13012);
            Detector Det13013 = Dets1.GetDetectorByNumber(13013);
            Detector Det13014 = Dets1.GetDetectorByNumber(13014);
            Detector Det13015 = Dets1.GetDetectorByNumber(13015);
            Detector Det13016 = Dets1.GetDetectorByNumber(13016);
            Detector Det13017 = Dets1.GetDetectorByNumber(13017);
            Detector Det13018 = Dets1.GetDetectorByNumber(13018);
            Detector Det13019 = Dets1.GetDetectorByNumber(13019);
            Detector Det13020 = Dets1.GetDetectorByNumber(13020);
            Detector Det13021 = Dets1.GetDetectorByNumber(13021);
            Detector Det13022 = Dets1.GetDetectorByNumber(13022);
            Detector Det13023 = Dets1.GetDetectorByNumber(13023);
            Detector Det13024 = Dets1.GetDetectorByNumber(13024);
            Detector Det13025 = Dets1.GetDetectorByNumber(13025);
            Detector Det13026 = Dets1.GetDetectorByNumber(13026);
            Detector Det13027 = Dets1.GetDetectorByNumber(13027);
            Detector Det13028 = Dets1.GetDetectorByNumber(13028);
            Detector Det13029 = Dets1.GetDetectorByNumber(13029);
            Detector Det13030 = Dets1.GetDetectorByNumber(13030);
            Detector Det13031 = Dets1.GetDetectorByNumber(13031);
            Detector Det13032 = Dets1.GetDetectorByNumber(13032);
            Detector Det13033 = Dets1.GetDetectorByNumber(13033);
            Detector Det13034 = Dets1.GetDetectorByNumber(13034);
            Detector Det13035 = Dets1.GetDetectorByNumber(13035);

            //NB through (right lane)
            Detector Det21001 = Dets1.GetDetectorByNumber(21001);
            Detector Det21002 = Dets1.GetDetectorByNumber(21002);
            Detector Det21003 = Dets1.GetDetectorByNumber(21003);
            Detector Det21004 = Dets1.GetDetectorByNumber(21004);
            Detector Det21005 = Dets1.GetDetectorByNumber(21005);
            Detector Det21006 = Dets1.GetDetectorByNumber(21006);
            Detector Det21007 = Dets1.GetDetectorByNumber(21007);
            Detector Det21008 = Dets1.GetDetectorByNumber(21008);
            Detector Det21009 = Dets1.GetDetectorByNumber(21009);
            Detector Det21010 = Dets1.GetDetectorByNumber(21010);
            Detector Det21011 = Dets1.GetDetectorByNumber(21011);
            Detector Det21012 = Dets1.GetDetectorByNumber(21012);
            Detector Det21013 = Dets1.GetDetectorByNumber(21013);
            Detector Det21014 = Dets1.GetDetectorByNumber(21014);
            Detector Det21015 = Dets1.GetDetectorByNumber(21015);
            Detector Det21016 = Dets1.GetDetectorByNumber(21016);
            Detector Det21017 = Dets1.GetDetectorByNumber(21017);
            Detector Det21018 = Dets1.GetDetectorByNumber(21018);
            Detector Det21019 = Dets1.GetDetectorByNumber(21019);
            Detector Det21020 = Dets1.GetDetectorByNumber(21020);
            Detector Det21021 = Dets1.GetDetectorByNumber(21021);
            Detector Det21022 = Dets1.GetDetectorByNumber(21022);
            Detector Det21023 = Dets1.GetDetectorByNumber(21023);
            Detector Det21024 = Dets1.GetDetectorByNumber(21024);
            Detector Det21025 = Dets1.GetDetectorByNumber(21025);
            Detector Det21026 = Dets1.GetDetectorByNumber(21026);
            Detector Det21027 = Dets1.GetDetectorByNumber(21027);
            Detector Det21028 = Dets1.GetDetectorByNumber(21028);
            Detector Det21029 = Dets1.GetDetectorByNumber(21029);
            Detector Det21030 = Dets1.GetDetectorByNumber(21030);
            Detector Det21031 = Dets1.GetDetectorByNumber(21031);
            Detector Det21032 = Dets1.GetDetectorByNumber(21032);
            Detector Det21033 = Dets1.GetDetectorByNumber(21033);
            Detector Det21034 = Dets1.GetDetectorByNumber(21034);
            Detector Det21035 = Dets1.GetDetectorByNumber(21035);
            Detector Det21036 = Dets1.GetDetectorByNumber(21036);
            Detector Det21037 = Dets1.GetDetectorByNumber(21037);
            Detector Det21038 = Dets1.GetDetectorByNumber(21038);
            Detector Det21039 = Dets1.GetDetectorByNumber(21039);
            Detector Det21040 = Dets1.GetDetectorByNumber(21040);
            Detector Det21041 = Dets1.GetDetectorByNumber(21041);
            Detector Det21042 = Dets1.GetDetectorByNumber(21042);
            Detector Det21043 = Dets1.GetDetectorByNumber(21043);
            Detector Det21044 = Dets1.GetDetectorByNumber(21044);
            Detector Det21045 = Dets1.GetDetectorByNumber(21045);
            Detector Det21046 = Dets1.GetDetectorByNumber(21046);
            Detector Det21047 = Dets1.GetDetectorByNumber(21047);
            Detector Det21048 = Dets1.GetDetectorByNumber(21048);
            Detector Det21049 = Dets1.GetDetectorByNumber(21049);
            Detector Det21050 = Dets1.GetDetectorByNumber(21050);
            Detector Det21051 = Dets1.GetDetectorByNumber(21051);
            Detector Det21052 = Dets1.GetDetectorByNumber(21052);
            Detector Det21053 = Dets1.GetDetectorByNumber(21053);
            Detector Det21054 = Dets1.GetDetectorByNumber(21054);
            Detector Det21055 = Dets1.GetDetectorByNumber(21055);
            Detector Det21056 = Dets1.GetDetectorByNumber(21056);
            Detector Det21057 = Dets1.GetDetectorByNumber(21057);
            Detector Det21058 = Dets1.GetDetectorByNumber(21058);
            Detector Det21059 = Dets1.GetDetectorByNumber(21059);
            Detector Det21060 = Dets1.GetDetectorByNumber(21060);
            Detector Det21061 = Dets1.GetDetectorByNumber(21061);
            Detector Det21062 = Dets1.GetDetectorByNumber(21062);
            Detector Det21063 = Dets1.GetDetectorByNumber(21063);
            Detector Det21064 = Dets1.GetDetectorByNumber(21064);
            Detector Det21065 = Dets1.GetDetectorByNumber(21065);
            Detector Det21066 = Dets1.GetDetectorByNumber(21066);
            Detector Det21067 = Dets1.GetDetectorByNumber(21067);
            Detector Det21068 = Dets1.GetDetectorByNumber(21068);
            Detector Det21069 = Dets1.GetDetectorByNumber(21069);
            Detector Det21070 = Dets1.GetDetectorByNumber(21070);
            Detector Det21071 = Dets1.GetDetectorByNumber(21071);
            Detector Det21072 = Dets1.GetDetectorByNumber(21072);
            Detector Det21073 = Dets1.GetDetectorByNumber(21073);
            Detector Det21074 = Dets1.GetDetectorByNumber(21074);
            Detector Det21075 = Dets1.GetDetectorByNumber(21075);
            Detector Det21076 = Dets1.GetDetectorByNumber(21076);
            Detector Det21077 = Dets1.GetDetectorByNumber(21077);
            Detector Det21078 = Dets1.GetDetectorByNumber(21078);
            Detector Det21079 = Dets1.GetDetectorByNumber(21079);
            Detector Det21080 = Dets1.GetDetectorByNumber(21080);
            Detector Det21081 = Dets1.GetDetectorByNumber(21081);
            Detector Det21082 = Dets1.GetDetectorByNumber(21082);
            Detector Det21083 = Dets1.GetDetectorByNumber(21083);
            Detector Det21084 = Dets1.GetDetectorByNumber(21084);
            Detector Det21085 = Dets1.GetDetectorByNumber(21085);
            Detector Det21086 = Dets1.GetDetectorByNumber(21086);
            Detector Det21087 = Dets1.GetDetectorByNumber(21087);
            Detector Det21088 = Dets1.GetDetectorByNumber(21088);
            Detector Det21089 = Dets1.GetDetectorByNumber(21089);
            Detector Det21090 = Dets1.GetDetectorByNumber(21090);
            Detector Det21091 = Dets1.GetDetectorByNumber(21091);
            Detector Det21092 = Dets1.GetDetectorByNumber(21092);
            Detector Det21093 = Dets1.GetDetectorByNumber(21093);
            Detector Det21094 = Dets1.GetDetectorByNumber(21094);
            Detector Det21095 = Dets1.GetDetectorByNumber(21095);
            Detector Det21096 = Dets1.GetDetectorByNumber(21096);
            Detector Det21097 = Dets1.GetDetectorByNumber(21097);
            Detector Det21098 = Dets1.GetDetectorByNumber(21098);
            Detector Det21099 = Dets1.GetDetectorByNumber(21099);

            //SB through (left lane)
            Detector Det22001 = Dets1.GetDetectorByNumber(22001);
            Detector Det22002 = Dets1.GetDetectorByNumber(22002);
            Detector Det22003 = Dets1.GetDetectorByNumber(22003);
            Detector Det22004 = Dets1.GetDetectorByNumber(22004);
            Detector Det22005 = Dets1.GetDetectorByNumber(22005);
            Detector Det22006 = Dets1.GetDetectorByNumber(22006);
            Detector Det22007 = Dets1.GetDetectorByNumber(22007);
            Detector Det22008 = Dets1.GetDetectorByNumber(22008);
            Detector Det22009 = Dets1.GetDetectorByNumber(22009);
            Detector Det22010 = Dets1.GetDetectorByNumber(22010);
            Detector Det22011 = Dets1.GetDetectorByNumber(22011);
            Detector Det22012 = Dets1.GetDetectorByNumber(22012);
            Detector Det22013 = Dets1.GetDetectorByNumber(22013);
            Detector Det22014 = Dets1.GetDetectorByNumber(22014);
            Detector Det22015 = Dets1.GetDetectorByNumber(22015);
            Detector Det22016 = Dets1.GetDetectorByNumber(22016);
            Detector Det22017 = Dets1.GetDetectorByNumber(22017);
            Detector Det22018 = Dets1.GetDetectorByNumber(22018);
            Detector Det22019 = Dets1.GetDetectorByNumber(22019);
            Detector Det22020 = Dets1.GetDetectorByNumber(22020);
            Detector Det22021 = Dets1.GetDetectorByNumber(22021);
            Detector Det22022 = Dets1.GetDetectorByNumber(22022);
            Detector Det22023 = Dets1.GetDetectorByNumber(22023);
            Detector Det22024 = Dets1.GetDetectorByNumber(22024);
            Detector Det22025 = Dets1.GetDetectorByNumber(22025);
            Detector Det22026 = Dets1.GetDetectorByNumber(22026);
            Detector Det22027 = Dets1.GetDetectorByNumber(22027);
            Detector Det22028 = Dets1.GetDetectorByNumber(22028);
            Detector Det22029 = Dets1.GetDetectorByNumber(22029);
            Detector Det22030 = Dets1.GetDetectorByNumber(22030);
            Detector Det22031 = Dets1.GetDetectorByNumber(22031);
            Detector Det22032 = Dets1.GetDetectorByNumber(22032);
            Detector Det22033 = Dets1.GetDetectorByNumber(22033);
            Detector Det22034 = Dets1.GetDetectorByNumber(22034);
            Detector Det22035 = Dets1.GetDetectorByNumber(22035);
            Detector Det22036 = Dets1.GetDetectorByNumber(22036);
            Detector Det22037 = Dets1.GetDetectorByNumber(22037);
            Detector Det22038 = Dets1.GetDetectorByNumber(22038);
            Detector Det22039 = Dets1.GetDetectorByNumber(22039);
            Detector Det22040 = Dets1.GetDetectorByNumber(22040);
            Detector Det22041 = Dets1.GetDetectorByNumber(22041);
            Detector Det22042 = Dets1.GetDetectorByNumber(22042);
            Detector Det22043 = Dets1.GetDetectorByNumber(22043);
            Detector Det22044 = Dets1.GetDetectorByNumber(22044);
            Detector Det22045 = Dets1.GetDetectorByNumber(22045);
            Detector Det22046 = Dets1.GetDetectorByNumber(22046);
            Detector Det22047 = Dets1.GetDetectorByNumber(22047);
            Detector Det22048 = Dets1.GetDetectorByNumber(22048);
            Detector Det22049 = Dets1.GetDetectorByNumber(22049);
            Detector Det22050 = Dets1.GetDetectorByNumber(22050);
            Detector Det22051 = Dets1.GetDetectorByNumber(22051);
            Detector Det22052 = Dets1.GetDetectorByNumber(22052);
            Detector Det22053 = Dets1.GetDetectorByNumber(22053);
            Detector Det22054 = Dets1.GetDetectorByNumber(22054);
            Detector Det22055 = Dets1.GetDetectorByNumber(22055);
            Detector Det22056 = Dets1.GetDetectorByNumber(22056);
            Detector Det22057 = Dets1.GetDetectorByNumber(22057);
            Detector Det22058 = Dets1.GetDetectorByNumber(22058);
            Detector Det22059 = Dets1.GetDetectorByNumber(22059);
            Detector Det22060 = Dets1.GetDetectorByNumber(22060);
            Detector Det22061 = Dets1.GetDetectorByNumber(22061);
            Detector Det22062 = Dets1.GetDetectorByNumber(22062);
            Detector Det22063 = Dets1.GetDetectorByNumber(22063);
            Detector Det22064 = Dets1.GetDetectorByNumber(22064);
            Detector Det22065 = Dets1.GetDetectorByNumber(22065);
            Detector Det22066 = Dets1.GetDetectorByNumber(22066);
            Detector Det22067 = Dets1.GetDetectorByNumber(22067);
            Detector Det22068 = Dets1.GetDetectorByNumber(22068);
            Detector Det22069 = Dets1.GetDetectorByNumber(22069);
            Detector Det22070 = Dets1.GetDetectorByNumber(22070);
            Detector Det22071 = Dets1.GetDetectorByNumber(22071);
            Detector Det22072 = Dets1.GetDetectorByNumber(22072);
            Detector Det22073 = Dets1.GetDetectorByNumber(22073);
            Detector Det22074 = Dets1.GetDetectorByNumber(22074);
            Detector Det22075 = Dets1.GetDetectorByNumber(22075);
            Detector Det22076 = Dets1.GetDetectorByNumber(22076);
            Detector Det22077 = Dets1.GetDetectorByNumber(22077);
            Detector Det22078 = Dets1.GetDetectorByNumber(22078);
            Detector Det22079 = Dets1.GetDetectorByNumber(22079);
            Detector Det22080 = Dets1.GetDetectorByNumber(22080);
            Detector Det22081 = Dets1.GetDetectorByNumber(22081);
            Detector Det22082 = Dets1.GetDetectorByNumber(22082);
            Detector Det22083 = Dets1.GetDetectorByNumber(22083);
            Detector Det22084 = Dets1.GetDetectorByNumber(22084);
            Detector Det22085 = Dets1.GetDetectorByNumber(22085);
            Detector Det22086 = Dets1.GetDetectorByNumber(22086);
            Detector Det22087 = Dets1.GetDetectorByNumber(22087);
            Detector Det22088 = Dets1.GetDetectorByNumber(22088);
            Detector Det22089 = Dets1.GetDetectorByNumber(22089);
            Detector Det22090 = Dets1.GetDetectorByNumber(22090);
            Detector Det22091 = Dets1.GetDetectorByNumber(22091);
            Detector Det22092 = Dets1.GetDetectorByNumber(22092);
            Detector Det22093 = Dets1.GetDetectorByNumber(22093);
            Detector Det22094 = Dets1.GetDetectorByNumber(22094);
            Detector Det22095 = Dets1.GetDetectorByNumber(22095);
            Detector Det22096 = Dets1.GetDetectorByNumber(22096);
            Detector Det22097 = Dets1.GetDetectorByNumber(22097);
            Detector Det22098 = Dets1.GetDetectorByNumber(22098);
            Detector Det22099 = Dets1.GetDetectorByNumber(22099);

            // SB left turn
            Detector Det23001 = Dets1.GetDetectorByNumber(23001);
            Detector Det23002 = Dets1.GetDetectorByNumber(23002);
            Detector Det23003 = Dets1.GetDetectorByNumber(23003);
            Detector Det23004 = Dets1.GetDetectorByNumber(23004);
            Detector Det23005 = Dets1.GetDetectorByNumber(23005);
            Detector Det23006 = Dets1.GetDetectorByNumber(23006);
            Detector Det23007 = Dets1.GetDetectorByNumber(23007);
            Detector Det23008 = Dets1.GetDetectorByNumber(23008);
            Detector Det23009 = Dets1.GetDetectorByNumber(23009);
            Detector Det23010 = Dets1.GetDetectorByNumber(23010);
            Detector Det23011 = Dets1.GetDetectorByNumber(23011);
            Detector Det23012 = Dets1.GetDetectorByNumber(23012);
            Detector Det23013 = Dets1.GetDetectorByNumber(23013);
            Detector Det23014 = Dets1.GetDetectorByNumber(23014);
            Detector Det23015 = Dets1.GetDetectorByNumber(23015);
            Detector Det23016 = Dets1.GetDetectorByNumber(23016);
            Detector Det23017 = Dets1.GetDetectorByNumber(23017);
            Detector Det23018 = Dets1.GetDetectorByNumber(23018);
            Detector Det23019 = Dets1.GetDetectorByNumber(23019);
            Detector Det23020 = Dets1.GetDetectorByNumber(23020);
            Detector Det23021 = Dets1.GetDetectorByNumber(23021);
            Detector Det23022 = Dets1.GetDetectorByNumber(23022);
            Detector Det23023 = Dets1.GetDetectorByNumber(23023);
            Detector Det23024 = Dets1.GetDetectorByNumber(23024);
            Detector Det23025 = Dets1.GetDetectorByNumber(23025);
            Detector Det23026 = Dets1.GetDetectorByNumber(23026);
            Detector Det23027 = Dets1.GetDetectorByNumber(23027);
            Detector Det23028 = Dets1.GetDetectorByNumber(23028);
            Detector Det23029 = Dets1.GetDetectorByNumber(23029);
            Detector Det23030 = Dets1.GetDetectorByNumber(23030);
            Detector Det23031 = Dets1.GetDetectorByNumber(23031);
            Detector Det23032 = Dets1.GetDetectorByNumber(23032);
            Detector Det23033 = Dets1.GetDetectorByNumber(23033);
            Detector Det23034 = Dets1.GetDetectorByNumber(23034);
            Detector Det23035 = Dets1.GetDetectorByNumber(23035);
            Detector Det23036 = Dets1.GetDetectorByNumber(23036);
            Detector Det23037 = Dets1.GetDetectorByNumber(23037);
            Detector Det23038 = Dets1.GetDetectorByNumber(23038);
            Detector Det23039 = Dets1.GetDetectorByNumber(23039);
            Detector Det23040 = Dets1.GetDetectorByNumber(23040);
            Detector Det23041 = Dets1.GetDetectorByNumber(23041);
            Detector Det23042 = Dets1.GetDetectorByNumber(23042);
            Detector Det23043 = Dets1.GetDetectorByNumber(23043);
            Detector Det23044 = Dets1.GetDetectorByNumber(23044);
            Detector Det23045 = Dets1.GetDetectorByNumber(23045);
            Detector Det23046 = Dets1.GetDetectorByNumber(23046);

            //EB & WB
            Detector Det30001 = Dets1.GetDetectorByNumber(30001);
            Detector Det40001 = Dets1.GetDetectorByNumber(40001);

            //define variables used for the signal control
            int phase_1_flag = 3; // status of phase 1 1:red, 3:green, 4:amber (NS left)
            int phase_2_flag = 1; // status of phase 1 1:red, 3:green, 4:amber (NS through)
            int phase_3_flag = 1; // status of phase 1 1:red, 3:green, 4:amber (EW)
            int AR_flag = 4; // all red phase indicator 1-3
            double phase_1_AR = 2; //  phase 1 all red
            double phase_2_AR = 3; //  phase 2 all red
            double phase_3_AR = 2; //  phase 3 all red
            double phase_1_Y = 5; //  phase 1 all red
            double phase_2_Y = 5.5; //  phase 2 all red
            double phase_3_Y = 5; //  phase 3 all red
            int phase_1_min = 5; // phase 1 min G
            int phase_2_min = 35; // phase 2 min G
            int phase_3_min = 8; // phase 2 min G
            int phase_1_max = 30; // phase 1 max G
            int phase_2_max = 75; // phase 2 max G
            int phase_3_max = 30; // phase 2 max G
            double current_G = 0; //current Green
            double projected_G = 3; //projected G
            double current_R = 0; //current Red
            double current_Y = 0; //current Yellow
            double phase_1_Ex = 3.5; //phase 1 G extension
            double phase_2_Ex = 6; //phase 2 G extension
            double phase_3_Ex = 4; //phase 3 G extension
            double SimPeriod = sim.Period;


            for (Double i = 0; i <= SimPeriod - 1; i=i+0.1)
            {
                sim.BreakAt = i + 0.1;                
                sim.RunContinuous();
                 
                if (i > 0)// enter control code from here
                {
                    //phase 1 NS left  
                    if (phase_1_flag == 3 && phase_2_flag == 1 && phase_3_flag == 1) //NS left turn green
                    {
                        if (current_G <= projected_G - 0.1 && current_G > 1.5)
                        {
                            //check det 50~200
                            double ext13 = Det13015.get_AttValue("presence") * Det13015.get_AttValue("speed");
                            double ext23 = Det23015.get_AttValue("presence") * Det23015.get_AttValue("speed");
                            if ((ext23 + ext13) > 1)
                            {
                                projected_G = current_G + phase_1_Ex;
                                if (projected_G >= phase_1_max)
                                {
                                    projected_G = phase_1_max;
                                }
                            }

                            if (projected_G < phase_1_min )
                            {
                                projected_G = projected_G + 0.1;
                            }
                            current_G = current_G + 0.1;
                        }else if (current_G > phase_1_min-0.1 || projected_G >= phase_1_max)
                            {
                                //change to yellow
                                phase_1_flag = 4;
                                current_G = 0;
                                projected_G = 3;
                                sc1_group1.set_AttValue("state", 4);
                            }
                            else
                            {
                                current_G = current_G + 0.1;
                            }
                        }
                    
                    if (phase_1_flag == 4 && phase_2_flag == 1 && phase_3_flag == 1) //NS left turn amber
                    {
                        if (current_Y < phase_1_Y)
                        { current_Y = current_Y + 0.1; } else
                        {
                            current_G = 0;
                            current_Y = 0;
                            current_R = 0;
                            AR_flag = 1;
                            phase_1_flag = 1;
                            projected_G = 0;
                            sc1_group1.set_AttValue("state", 1);
                        }
                    }

                    if (phase_1_flag == 1 && phase_2_flag == 1 && phase_3_flag == 1 && AR_flag == 1) //NS left turn AR
                    {
                        if (current_R < phase_1_AR)
                        { current_R = current_R + 0.1; } else
                        {
                            current_G = 0;
                            current_Y = 0;
                            current_R = 0;
                            phase_2_flag = 3;
                            AR_flag = 4;
                            projected_G = 3;
                            sc1_group2.set_AttValue("state", 3);
                        }
                    }

                    //phase 2 start from here
                    if (phase_2_flag == 3 && phase_1_flag == 1 && phase_3_flag == 1) //NS through green
                    {
                        if (current_G <= projected_G - 0.1 && current_G > 28)
                        {
                            //check det 50~200
                            double ext12 = Det12041.get_AttValue("presence") * Det12041.get_AttValue("speed");
                            double ext11 = Det11041.get_AttValue("presence") * Det11041.get_AttValue("speed");
                            double ext21 = Det22041.get_AttValue("presence") * Det22041.get_AttValue("speed");
                            double ext22 = Det21041.get_AttValue("presence") * Det21041.get_AttValue("speed");
                            if ((ext12 + ext11 + ext21 + ext22) > 1)
                            {
                                projected_G = current_G + phase_2_Ex;
                                if (projected_G >= phase_2_max)
                                {
                                    projected_G = phase_2_max;
                                }
                                if (projected_G < phase_2_min)
                                { projected_G = projected_G + 0.1; }
                                current_G = current_G + 0.1;
                            }
                        }
                        else if (current_G >= phase_2_min - 0.1 || projected_G >=phase_2_max)
                        {
                                //change to yellow
                                phase_2_flag = 4;
                                current_G = 0;
                                projected_G = 3;
                                sc1_group2.set_AttValue("state", 4);
                        } else
                            {
                                current_G = current_G + 0.1;
                            }
                    }
                    if (phase_2_flag == 4 && phase_1_flag == 1 && phase_3_flag == 1) //NS through amber
                    {
                        if (current_Y < phase_2_Y)
                        { current_Y = current_Y + 0.1; } else
                        {
                            current_G = 0;
                            current_Y = 0;
                            current_R = 0;
                            AR_flag = 2;
                            phase_2_flag = 1;
                            projected_G = 3;
                            sc1_group2.set_AttValue("state", 1);
                        }
                    }

                    if (phase_2_flag == 1 && phase_1_flag == 1 && phase_3_flag == 1 && AR_flag == 2) //NS through AR
                    {
                        if (current_R < phase_2_AR)
                        { current_R = current_R + 0.1; } else
                        {
                            current_G = 0;
                            current_Y = 0;
                            current_R = 0;
                            phase_3_flag = 3;
                            AR_flag = 4;
                            projected_G = 3;
                            sc1_group3.set_AttValue("state", 3);
                        }
                    }

                    //phase 3 starts
                    if (phase_3_flag == 3 && phase_1_flag == 1 && phase_1_flag == 1) //Croom green
                    {
                        if (current_G <= projected_G-0.1 && current_G > 4)
                        {
                            //check det 
                            double ext3 = Det30001.get_AttValue("presence") * Det30001.get_AttValue("speed");
                            double ext4 = Det40001.get_AttValue("presence") * Det40001.get_AttValue("speed");
                            if ((ext3 + ext4) > 1)
                            {
                                projected_G = current_G + phase_3_Ex;
                                if (projected_G >= phase_3_max)
                                {
                                    projected_G = phase_3_max;
                                }
                            }
                            if (projected_G < phase_3_min)
                            {
                                projected_G = projected_G + 0.1;
                            }
                                current_G = current_G + 0.1;
                        }
                        else if (current_G >= phase_3_min - 0.1 || projected_G >= phase_3_max)
                        {
                            //change to yellow
                            phase_3_flag = 4;
                            current_G = 0;
                            projected_G = 3;
                            sc1_group3.set_AttValue("state", 4);
                        } else
                        {
                            current_G = current_G + 0.1;
                        }
                    }
                    if (phase_3_flag == 4 && phase_1_flag == 1 && phase_2_flag == 1) //croom amber
                    {
                        if (current_Y < phase_3_Y)
                        { current_Y = current_Y + 0.1; }
                        else
                        {
                            current_G = 0;
                            current_Y = 0;
                            current_R = 0;
                            AR_flag = 3;
                            phase_3_flag = 1;
                            projected_G = 3;
                            sc1_group3.set_AttValue("state", 1);
                        }
                    }

                    if (phase_3_flag == 1 && phase_1_flag == 1 && phase_2_flag == 1 && AR_flag == 3) //croom AR
                    {
                        if (current_R < phase_3_AR)
                        { current_R = current_R + 0.1; }
                        else
                        {
                            current_G = 0;
                            current_Y = 0;
                            current_R = 0;
                            phase_1_flag = 3;
                            AR_flag = 4;
                            projected_G = 3;
                            sc1_group1.set_AttValue("state", 3);
                        }
                    }


                }//end of control code


            }
            Console.WriteLine("Hello, World!");            
            Console.WriteLine("The simulation period is:");
            Console.WriteLine(sim.Period);
            vis.Exit();
            Console.ReadKey();
        }
    }
}
